# coding: utf-8

"""
    Alfresco Content Services REST API

    **Core API**  Provides access to the core features of Alfresco Content Services.   # noqa: E501

    OpenAPI spec version: 1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from alfresco_core_api_client.configuration import Configuration


class RatingBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'my_rating': 'str'
    }

    attribute_map = {
        'id': 'id',
        'my_rating': 'myRating'
    }

    def __init__(self, id='likes', my_rating=None, _configuration=None):  # noqa: E501
        """RatingBody - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._id = None
        self._my_rating = None
        self.discriminator = None

        self.id = id
        self.my_rating = my_rating

    @property
    def id(self):
        """Gets the id of this RatingBody.  # noqa: E501

        The rating scheme type. Possible values are likes and fiveStar.  # noqa: E501

        :return: The id of this RatingBody.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this RatingBody.

        The rating scheme type. Possible values are likes and fiveStar.  # noqa: E501

        :param id: The id of this RatingBody.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501
        allowed_values = ["likes", "fiveStar"]  # noqa: E501
        if (self._configuration.client_side_validation and
                id not in allowed_values):
            raise ValueError(
                "Invalid value for `id` ({0}), must be one of {1}"  # noqa: E501
                .format(id, allowed_values)
            )

        self._id = id

    @property
    def my_rating(self):
        """Gets the my_rating of this RatingBody.  # noqa: E501

        The rating. The type is specific to the rating scheme, boolean for the likes and an integer for the fiveStar  # noqa: E501

        :return: The my_rating of this RatingBody.  # noqa: E501
        :rtype: str
        """
        return self._my_rating

    @my_rating.setter
    def my_rating(self, my_rating):
        """Sets the my_rating of this RatingBody.

        The rating. The type is specific to the rating scheme, boolean for the likes and an integer for the fiveStar  # noqa: E501

        :param my_rating: The my_rating of this RatingBody.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and my_rating is None:
            raise ValueError("Invalid value for `my_rating`, must not be `None`")  # noqa: E501

        self._my_rating = my_rating

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RatingBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RatingBody):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, RatingBody):
            return True

        return self.to_dict() != other.to_dict()
